<?php
	// Atom feed support
	// (c) 2004 Javier Gutirrez Chamorro (Guti), guti <at> ya <dot> com
	//
	// Simple PHP Version: 0.8.0
	// Atom Version:   0.8.0
	
	function clean_atom_output ( $str ) {
		// Decode/Encode HTML output
		global $lang_string, $blog_config;
		$str = html_entity_decode( $str, ENT_QUOTES, $lang_string['php_charset'] );
		$str = htmlspecialchars( $str, ENT_QUOTES, $lang_string['php_charset'] );
		
		return( $str );
	}

	function generate_atom ( $max_entries=0 )
	{
		// Read entries by month, year and/or day. Generate HTML output.
		//
		// Used for the main Index page.
		global $lang_string, $blog_config, $user_colors, $sb_info;
		
		$entry_file_array = blog_entry_listing();

		// Flip entry order
		if ( $blog_config[ 'blog_entry_order' ] == 'old_to_new' ) {
			$entry_file_array = array_reverse( $entry_file_array );
		}
		
		if ( ( dirname($_SERVER['PHP_SELF']) == '\\' || dirname($_SERVER['PHP_SELF']) == '/' ) ) {
			// Hosted at root.
			$base_url = 'http://'.$_SERVER['HTTP_HOST'].'/';
		} else {
			// Hosted in sub-directory.
			$base_url = 'http://'.$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).'/';
		}
		
		header('Content-type: application/xml');
		echo '<?xml version="1.0" encoding="ISO-8859-2" ?'. ">\n";
		echo '<feed version="0.3" xmlns="http://purl.org/atom/ns#" xml:lang="' . str_replace('_', '-', $lang_string['locale']) . "\">\n";
		//Required channel fields
		echo "\t<title>" . clean_atom_output( $blog_config[ 'blog_title' ] ) . "</title>\n";
		echo "\t<link rel=\"alternate\" type=\"text/html\" href=\"" . $base_url . "index.php\" />\n";
		echo "\t<modified>" . gmdate( 'Y-m-d' ) . 'T' . gmdate( 'H:i:s' ) . "Z</modified>\n";
		//Optional channel fields
		echo "\t<author>\n";
		echo "\t\t<name>" . clean_atom_output( $blog_config[ 'blog_author' ] ) . "</name>\n";
		echo "\t\t<email>" . clean_atom_output( $blog_config[ 'blog_email' ] ) . "</email>\n";
		echo "\t</author>\n";
		echo "\t<copyright>" . clean_atom_output( 'Copyright ' . strftime( '%Y' ) . ', ' . $blog_config[ 'blog_author' ] ) . "</copyright>\n";
		echo "\t<generator url=\"http://www.sourceforge.net/projects/sphpblog\" version=\"" . $sb_info[ 'version' ] . "\">SPHPBLOG</generator>\n";

		// Read entry files
		if ( $max_entries<=0 ) {
			$max_entries=min( $blog_config[ 'blog_max_entries' ], count( $entry_file_array ) );
		}
		else {
			$max_entries=min( $max_entries, count( $entry_file_array ) );
		}
		
		for ( $i = 0; $i < $max_entries; $i++ ) {
			list( $entry_filename, $year_dir, $month_dir ) = explode( '|', $entry_file_array[ $i ] );
			$contents=array( 'text' => sb_read_file( 'content/' . $year_dir . '/' . $month_dir . '/' . $entry_filename ), 'entry' => $entry_filename );
			list( $blog_subject, $blog_date, $blog_text ) = explode('|', ( $contents['text'] ) );
			echo "\t<entry>\n";
			//Required item fields
			echo "\t\t<title>" . clean_atom_output( blog_to_html( $blog_subject, false, false ) ) . "</title>\n";
			echo "\t\t<link rel=\"alternate\" type=\"text/html\" href=\"" . $base_url . "index.php?entry=" . sb_strip_extension( $entry_filename ) . "\" />\n";
			echo "\t\t<content type=\"text/html\" mode=\"escaped\"><![CDATA[" . blog_to_html( $blog_text, false, false ) . "]]></content>\n";
			//Optional item fields
			echo "\t\t<id>" . $base_url . "index.php?entry=" . sb_strip_extension( $entry_filename ) . "</id>\n";
			echo "\t\t<issued>" . gmdate( 'Y-m-d', $blog_date ) . 'T' . gmdate( 'H:i:s', $blog_date ) . "Z</issued>\n";
			echo "\t\t<modified>" . gmdate( 'Y-m-d', $blog_date ) . 'T' . gmdate( 'H:i:s', $blog_date ) . "Z</modified>\n";
			// Only output if <comments> if they are enabled.
			if ( $blog_config[ 'blog_enable_comments' ] ) {
				//echo "\t\t<comments>" . $base_url . "comments.php?y=" . $year_dir . "&amp;m=" . $month_dir . "&amp;entry=" . sb_strip_extension( $entry_filename ) . "</comments>\n";
			}
			echo "\t</entry>\n";
		}
		echo "</feed>\n";
	}
	
	// Include Required Functions
	require('scripts/sb_functions.php');
	
	read_config();
	
	require('languages/' . $blog_config[ 'blog_language' ] . '/strings.php');
	sb_language( 'index' );
	
	// Output Page
	generate_atom( @$_GET['n'] );
?>
